from curses import *

def colorize(str, color):
  return tparm(tigetstr("setaf"), color) + str + tigetstr("sgr0")

class fooPrinter:
  """Print a foo object."""
     
  def __init__(self, val):
     self.val = val
     
  def to_string(self):
     return ("a=<" + str(self.val["a"]) +
             "> b=<" + str(self.val["b"]) + ">")

  def to_color_string(self):
     return (colorize("a", COLOR_RED) + colorize("=", COLOR_BLUE) + colorize("<", COLOR_GREEN) + str(self.val["a"]) +
             colorize(">", COLOR_GREEN) + "b=<" + str(self.val["b"]) + ">")
     
class barPrinter:
  """Print a bar object."""
     
  def __init__(self, val):
     self.val = val
     
  def to_string(self):
     return ("x=<" + str(self.val["x"]) +
                     "> y=<" + str(self.val["y"]) + ">")
import gdb.printing
     
def build_pretty_printer():
   pp = gdb.printing.RegexpCollectionPrettyPrinter("my_library")
   pp.add_printer('foo', '^foo$', fooPrinter)
   pp.add_printer('bar', '^bar$', barPrinter)
   return pp

gdb.printing.register_pretty_printer(gdb.current_objfile(),build_pretty_printer())
setupterm(None, 1);
